HDU 2955:Robberies (01背包)

Robberies

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 20669    Accepted Submission(s): 7656


Problem Description
The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.

con211-1010-1
For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.

 

Input
The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj .
Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .

 

Output
For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.Notes and Constraints
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.

 

Sample Input
3
0.04 3
1 0.02
2 0.03
3 0.05
0.06 3
2 0.03
2 0.03
3 0.05
0.10 3
1 0.03
2 0.02
3 0.05

 

Sample Output
2
4
6

 

题意:有一个小偷要偷银行的钱,可是他偷每家银行总是有一定的概率被抓,现在给了你一个概率P,问保证他在安全的情况下,他最多可以偷多少钱。
  题目中有说明给出概率,然后测试样例里面的概率都是两位小数,那是不是说明所有的测试数据都是两位小数,我们可以给概率*100,然后转换成最简单的01背包呢?
  不幸的是,经过我的测试,这种思路是不对的,因为测试数据中的小数不止两位。

 

  那我们就要换一种思路啦!给出的概率P是他在这个银行被抓的概率,那么(1-P)就是它逃跑概率咯!
  他经过所有的银行的总逃跑概率就是所有逃跑概率的乘积啦!既然这样,我们可以把所有银行的总钱数看做背包的容量,逃跑的概率看做价值,那么同样是一个01背包问题,只不过这个01背包计算的是它的最大逃跑概率。

状态转移方程为:dp[j]=max(dp[j],dp[j-a[i].vi]*(1.0-a[i].p));

  然后经过两重循环的dp之后,我们可以计算出在所有可能抢到的钱数所有的逃跑概率,然后只需要从总钱数开始往下枚举,只要逃跑概率满足第二行输入的概率就可以啦!

 

AC代码:
#include <stdio.h>
#include<iostream>
#include<algorithm>
#include<string.h>
#define max(a,b) (a>b?a:b)
using namespace std;
struct po
{
    int vi;
    double p;
} a[10010];
double dp[10010];
int main()
{
    int T;
    scanf("%d",&T);
    double m,n;
    while(T--)
    {
        memset(dp,0,sizeof(dp));
        scanf("%lf%lf",&m,&n);
        int sum=0;
        for(int i=0; i<n; i++)
        {
            scanf("%d%lf",&a[i].vi,&a[i].p);
            sum+=a[i].vi;
        }
        dp[0]=1;
        for(int i=0; i<n; i++)
            for(int j=sum; j>=a[i].vi; j--)
                dp[j]=max(dp[j],dp[j-a[i].vi]*(1.0-a[i].p));
        for(int i=sum; i>=0; i--)
            if(dp[i]>1-m)
            {
                printf("%d\n",i);
                break;
            }
    }
    return 0;
}

我想对千千说~